/*
 *  CabriConsoleMacros.h
 *  Geometre II Plus
 *
 *  Created by Albert Vaillant on 6/25/05.
 *  Copyright 2005 Cabrilog. All rights reserved.
 *
 */
#ifdef DEBUG
#define CABRICONSOLE_DEBUG		1
#endif

#ifdef _XCODE_DEBUG
#define Assert(cond)	assert(cond)
#else
#define Assert(cond)
#endif

#ifndef CABRICONSOLE_DEBUG
	#define CABRICONSOLE_DEBUG	0
#endif

#if !CABRICONSOLE_DEBUG
	
	// CONSOLE MACROS
	
	#define PUTCHAR_DBG(c) ;

	#define PRINTF_DBG(format) ;
	#define PRINTF_DBG0(format,a0) ;
	#define PRINTF_DBG1(format,a0) ;
	#define PRINTF_DBG2(format,a0,a1) ;
	#define PRINTF_DBG3(format,a0,a1,a2) ;
	#define PRINTF_DBG4(format,a0,a1,a2,a3) ;
	#define PRINTF_DBG5(format,a0,a1,a2,a3,a5) ;
	#define PRINTF_DBG6(format,a0,a1,a2,a3,a5,a6) ;

	#define PRINTF_NSRECT_DBG(name,rect);
	#define PRINTF_NSPOINT_DBG(name,point);
	#define PRINTF_NSSIZE_DBG(name,size);
	
	#define PUTCHAR_DBG_IF(c,flag) ;

	#define PRINTF_DBG_IF(format,flag) ;
	#define PRINTF_DBG0_IF(format,a0,flag) ;
	#define PRINTF_DBG1_IF(format,a0,flag) ;
	#define PRINTF_DBG2_IF(format,a0,a1,flag) ;
	#define PRINTF_DBG3_IF(format,a0,a1,a2,flag) ;
	#define PRINTF_DBG4_IF(format,a0,a1,a2,a3,flag) ;
	#define PRINTF_DBG5_IF(format,a0,a1,a2,a3,a5,flag) ;
	#define PRINTF_DBG6_IF(format,a0,a1,a2,a3,a5,a6,flag) ;

	#define PRINTF_NSRECT_DBG_IF(name,rect,flag);
	#define PRINTF_NSPOINT_DBG_IF(name,point,flag);
	#define PRINTF_NSSIZE_DBG_IF(name,size,flag);
	
	#define WARNING_DBG(string)	;
#else

	// CONDITIONNAL DEBUG MACROS

	#define PUTCHAR_DBG_IF(c,flag) { if (flag) putchar(c); }

	#define PRINTF_DBG_IF(format,flag) { if (flag) printf(format); }
	#define PRINTF_DBG0_IF(format,flag) { if (flag) printf(format); }
	#define PRINTF_DBG1_IF(format,a0,flag) { if (flag) printf(format,a0); }
	#define PRINTF_DBG2_IF(format,a0,a1,flag) { if (flag) printf(format,a0,a1); }
	#define PRINTF_DBG3_IF(format,a0,a1,a2,flag) { if (flag) printf(format,a0,a1,a2); }
	#define PRINTF_DBG4_IF(format,a0,a1,a2,a3,flag) { if (flag) printf(format,a0,a1,a2,a3); }
	#define PRINTF_DBG5_IF(format,a0,a1,a2,a3,a5,flag) { if (flag) printf(format,a0,a1,a2,a3,a5); }
	#define PRINTF_DBG6_IF(format,a0,a1,a2,a3,a5,a6,flag) { if (flag) printf(format,a0,a1,a2,a3,a5,a6); }

	#define PRINTF_NSRECT_DBG_IF(name,rect,flag) { if (flag) { printf(name);printf(": (%i,%i) (%i,%i) %i x %i\n",(long)round(rect.origin.x),(long)round(rect.origin.y),(long)round(rect.size.width+rect.origin.x),(long)round(rect.size.height+rect.origin.y),(long)round(rect.size.width),(long)round(rect.size.height));} }
	#define PRINTF_NSPOINT_DBG_IF(name,point,flag) { if (flag) { printf(name);printf(": (%i,%i)\n",(long)round(point.x),(long)round(point.y) );} }
	#define PRINTF_NSSIZE_DBG_IF(name,size,flag)	 { if (flag) { printf(name);printf(": (%i,%i)\n",(long)round(size.width),(long)round(size.height) );} }

	#define WARNING_DBG_IF(string,flag)	PRINTF_DBG1_IF("### WARNING : %s\n",string,flag)
	
	// DEBUG MACROS

	#define PUTCHAR_DBG(c) putchar(c)

	#define PRINTF_DBG(format) printf(format)
	#define PRINTF_DBG0(format) printf(format)
	#define PRINTF_DBG1(format,a0) printf(format,a0)
	#define PRINTF_DBG2(format,a0,a1) printf(format,a0,a1)
	#define PRINTF_DBG3(format,a0,a1,a2) printf(format,a0,a1,a2)
	#define PRINTF_DBG4(format,a0,a1,a2,a3) printf(format,a0,a1,a2,a3)
	#define PRINTF_DBG5(format,a0,a1,a2,a3,a5) printf(format,a0,a1,a2,a3,a5)
	#define PRINTF_DBG6(format,a0,a1,a2,a3,a5,a6) printf(format,a0,a1,a2,a3,a5,a6)

	#define PRINTF_NSRECT_DBG(name,rect)	PRINTF_NSRECT_DBG_IF(name,rect,1)
	#define PRINTF_NSPOINT_DBG(name,point)	PRINTF_NSPOINT_DBG_IF(name,point,1)
	#define PRINTF_NSSIZE_DBG(name,size)	PRINTF_NSSIZE_DBG_IF(name,size,1)
	
	#define WARNING_DBG(string)	PRINTF_DBG1("### WARNING : %s\n",string)
#endif

/*
class CabriConsole
{
public:
		static inline PRINTF_DBG(const char* s) { printf(s); }
		static inline PUTCHAR_DBG(char *c) { putchar(c); }
	
};
*/