//
//  NSCabriXMLParser.h
//  Geometre II Plus
//
//  Created by Albert Vaillant on 6/24/05.
//  Copyright 2005 Cabrilog. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSCabriXMLParser : NSObject
{
	NSURL				*xmlDocumentURL;
	NSXMLParser			*nsParser;
	NSString			*currentName;
	NSMutableString		*currentStringValue;
	NSString			*currentProperty;
	
	NSDictionary		*currentAttributes;
}
 
//-(id)init;
-(void)dealloc;
 
// Static initialisation functions
+ (NSCabriXMLParser*)initWithFile:(NSString*)filePath;
+ (NSCabriXMLParser*)initWithBundleFile:(NSString*)filePath;

// parse the file.
- (void) attachFile:(NSString*)path;
- (void) attachURL:(NSURL*)url;
- (void) parseXMLFile;

// Override these methods to get elements.
- (void) gotError:(NSError*)inError;
- (void) gotXMLElement;
- (void) endXMLElement;

// Get current parsed item properties.
- (NSString*) getName;
- (NSString*) getStringValue;
- (NSString*) getProperty;

// Static utilities
+(NSString*)getXMLEncoding:(NSStringEncoding)inEncoding;

@end
