/* NSToolsWindowController */

#import <Cocoa/Cocoa.h>
#define	_DISPLAY_BACK_WHILE_EDITING	1

#import "NSCabriToolsPanelView.h"

@interface NSToolsWindowController : NSWindowController
{
    IBOutlet id		toolsPanel;					// the toolsPanel window
    IBOutlet id		toolsPanelView;				// the view inside the tools window
    IBOutlet id		toolsConfigurationDialog;	// the tools configuration panel
//    IBOutlet id		toolsCtxMenu;				// contextual menu
	IBOutlet id		toolsPalette;				// the tools floating palette
	IBOutlet id		enterPassword;			
	IBOutlet id		definePassword;			
	
	IBOutlet id		passwordSheet;
	bool			passwordProtection;
	NSString*		password;
	
	NSRect			desktopRect;			// the desktop area, in fact the rect frame,
											// minus the menubar and dock area
																
	BOOL			sideBarVisible;			// true if ther is a side bar
	
//	bool			reorganizing;
	bool			saveConfig;
	
//	NSMutableArray	*toolsArray;
	BOOL			restoreattributewindow;
}

-(IBAction)iconOrganizerCommand:(id)sender;

-(IBAction)enterReorganizeIcons:(id)sender;
-(IBAction)endReorganizeIcons:(id)sender;
-(IBAction)exitReorganizeIcons:(id)sender;
-(IBAction)loadPreset:(id)sender;
-(IBAction)saveToFileAction:(id)sender;

-(void)calcDesktopRect;
-(void)adjustSize;

// Buttons Management
#ifdef _ALBERT_TOOLS
-(void)addToolButton:(NSCabriToolButton*)button;
#endif
// Appearance 

-(IBAction)toggleSideBar:(id)sender;
-(BOOL)sideBarVisible;

-(IBAction)toggleIconSize:(id)sender;
-(long)iconSize;

-(void)setPassword;
-(void)resetConfiguration;

//-(id)toolsCtxMenu;
//-(void)refreshToolsCtxMenu;

// Preset

-(OSErr)loadPreset;

// ---- Notifications ----
-(void)languageLoaded:(id)sender;


@end
